<template>
  <div/>
</template>

<script>
import { marker, icon } from 'leaflet'
import { SET_WORKSPACE_QUERY, REMOVE_WORKSPACE_CUSTOM_LOCAL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletGetter from '@/workspace/mixins/LeafletGetter'
import MarkerIconImage from '@/assets/images/map-marker.png'

const malmoLocationIcon = icon({
  iconUrl: MarkerIconImage,
  iconSize: [32, 32],
  iconAnchor: [16, 16],
})

export default {
  name: 'locationmarker',

  mixins: [
    WorkspaceGetter,
    LeafletGetter,
  ],

  props: {
    locationId: {
      type: String,
      required: true
    },
  },

  computed: {
    location: {
      get() {
        return this.$store.getters.workspaceLocationById(this.workspaceId, this.locationId)
      }
    },

    status: {
      get() {
        return this.location.status
      },
    },
  },

  watch: {
    status() {
      if(this.location.status) {
        this.__markerObject.addTo(this.leafletMap)
      } else {
        this.__markerObject.remove()
      }
    }
  },

  mounted() {
    this.__markerObject = marker([this.location.latitude, this.location.longitude], {
      icon: malmoLocationIcon,
    }).on('click', () => {
      this.$store.commit(REMOVE_WORKSPACE_CUSTOM_LOCAL, {
        workspaceId: this.workspaceId
      })
      this.$nextTick(() => {
        this.$store.commit(SET_WORKSPACE_QUERY, {
          workspaceId: this.workspaceId,
          query: {
            isStation: false,
            latitude: this.location.latitude,
            longitude: this.location.longitude
          }
        })
      })
    })

    if(this.location.status) this.__markerObject.addTo(this.leafletMap)
  },

  destroyed() {
    this.__markerObject.remove()
  },
}
</script>
